import scg.ac.ni.pmf.newgraph.generator.GraphGenerator;
import scg.ac.ni.pmf.newgraph.graphdata.Graph;
import scg.ac.ni.pmf.newgraph.graphdata.Vertex;
import scg.ac.ni.pmf.newgraph.param.Parametrizable;

public class BinaryTreeGen implements GraphGenerator, Parametrizable {

	public String getName() {
		return "Binary Tree";
	}

	public String getDescription() {
		return "Creates a binary tree of the desired depth.";
	}

	public void newGraph(Graph graph) {
		generateTree(graph, depth, 0, 0);
	}
	
	private Vertex generateTree(Graph graph, int d, double x, double y) {
		Vertex v = graph.createVertex(x, y);
		if(d > 1) {
			double size = 10 * Math.pow(2, d - 1);
			Vertex a = generateTree(graph, d - 1, x - size, y + size);
			Vertex b = generateTree(graph, d - 1, x + size, y + size);
			graph.createEdge(v, a);
			graph.createEdge(v, b);
		}
		return v;
	}

	private int depth;

	public int getDepth() {
		return depth;
	}

	public void setDepth(int depth) {
		this.depth = depth;
	}
	
	public String checkParameters() {
		if(depth <= 0)
			return "Depth must be positive";
		else
			return null;
	}

}
